library ExtTest;
{$ALIGN OFF}  // needed for PasScript!!!

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses ShareMem, SysUtils;
const CRLF = #13#10;

type TRecord = record I: Integer; B: Boolean; R: Real end;
type TRecord2 = record B1, B2: Boolean end;
type TArray1 = array[1..2] of Char;
type TArray2 = array[1..200] of Integer;

function FmtBool(const B: Boolean): String;
begin if B then Result := 'true' else Result := 'false' end;

function STD_MultiParam(a,b,c,d,e: Integer; f: double; g: String; h: TRecord; i:TRecord2): String; stdcall;
begin Result := Format('%d  %d  %d  %d  %d  %g  %s  %d  %s  %g  %s  %s',
												[a,b,c,d,e,f,g,h.I,FmtBool(h.B),h.R,FmtBool(i.B1),FmtBool(i.B2)]);
end;
exports STD_MultiParam;

function REG_MultiParam(a,b,c,d,e: Integer; f: double; g: String; h: TRecord; i:TRecord2): String; register;
begin Result := Format('%d  %d  %d  %d  %d  %g  %s  %d  %s  %g  %s  %s',
												[a,b,c,d,e,f,g,h.I,FmtBool(h.B),h.R,FmtBool(i.B1),FmtBool(i.B2)]);
end;
exports REG_MultiParam;

function PAS_MultiParam(a,b,c,d,e: Integer; f: double; g: String; h: TRecord; i:TRecord2): String; pascal;
begin Result := Format('%d  %d  %d  %d  %d  %g  %s  %d  %s  %g  %s  %s',
												[a,b,c,d,e,f,g,h.I,FmtBool(h.B),h.R,FmtBool(i.B1),FmtBool(i.B2)]);
end;
exports PAS_MultiParam;

function CDECL_MultiParam(a,b,c,d,e: Integer; f: double; g: String; h: TRecord; i:TRecord2): String; cdecl;
begin Result := Format('%d  %d  %d  %d  %d  %g  %s  %d  %s  %g  %s  %s',
												[a,b,c,d,e,f,g,h.I,FmtBool(h.B),h.R,FmtBool(i.B1),FmtBool(i.B2)]);
end;
exports CDECL_MultiParam;

function SAFE_MultiParam(a,b,c,d,e: Integer; f: double; g: String; h: TRecord; i:TRecord2): String; safecall;
begin Result := Format('%d  %d  %d  %d  %d  %g  %s  %d  %s  %g  %s  %s',
												[a,b,c,d,e,f,g,h.I,FmtBool(h.B),h.R,FmtBool(i.B1),FmtBool(i.B2)]);
end;
exports SAFE_MultiParam;

////////////////////////////
function SAFE_RetString(a: integer): String; safecall;
begin result := 'abc'; end;
exports SAFE_RetString;
//////////////////////////////////////////////////////////////////
// STRING
//////////////////////////////////////////////////////////////////
procedure STD_Str_Val(S: String); stdcall;
begin WriteLn('String by value: ' + S); end;
exports STD_Str_Val;

procedure STD_Str_Var(var S: String); stdcall;
begin S := '[' + S + ']' end;
exports STD_Str_Var;

procedure CDECL_Str_Val(S: String); cdecl;
begin WriteLn('String by value: ' + S); end;
exports CDECL_Str_Val;

procedure CDECL_Str_Var(var S: String); cdecl;
begin S := '[' + S + ']' end;
exports CDECL_Str_Var;

procedure REG_Str_Val(S: String); register;
begin WriteLn('String by value: ' + S); end;
exports REG_Str_Val;

procedure REG_Str_Var(var S: String); register;
begin S := '[' + S + ']' end;
exports REG_Str_Var;

procedure PAS_Str_Val(S: String); pascal;
begin WriteLn('String by value: ' + S); end;
exports PAS_Str_Val;

procedure PAS_Str_Var(var S: String); pascal;
begin S := '[' + S + ']' end;
exports PAS_Str_Var;

procedure SAFE_Str_Val(S: String); safecall;
begin WriteLn('String by value: ' + S); end;
exports SAFE_Str_Val;

procedure SAFE_Str_Var(var S: String); safecall;
begin S := '[' + S + ']' end;
exports SAFE_Str_Var;

//////////////////////////////////////////////////////////////////
// ENUM
//////////////////////////////////////////////////////////////////
type TEnum = (Red, Blue, Green);

procedure STD_Enum_Val(E: TEnum); stdcall;
var S: String;
begin
  case E of
    Red: S := 'Red';    Blue: S := 'Blue';    Green: S := 'Green';
    else S := 'Invalid Enum value!';
  end;
  WriteLn('Enum by value: ', S);
end;
exports STD_Enum_Val;

procedure STD_Enum_Var(var E: TEnum); stdcall;
begin if E < Green then Inc(E) else E := Red end;
exports STD_Enum_Var;

procedure CDECL_Enum_Val(E: TEnum); cdecl;
var S: String;
begin
  case E of
    Red: S := 'Red';    Blue: S := 'Blue';    Green: S := 'Green';
    else S := 'Invalid Enum value!';
  end;
  WriteLn('Enum by value: ', S);
end;
exports CDECL_Enum_Val;

procedure CDECL_Enum_Var(var E: TEnum); cdecl;
begin if E < Green then Inc(E) else E := Red end;
exports CDECL_Enum_Var;

procedure REG_Enum_Val(E: TEnum); register;
var S: String;
begin
  case E of
    Red: S := 'Red';    Blue: S := 'Blue';    Green: S := 'Green';
    else S := 'Invalid Enum value!';
  end;
  WriteLn('Enum by value: ', S);
end;
exports REG_Enum_Val;

procedure REG_Enum_Var(var E: TEnum); register;
begin if E < Green then Inc(E) else E := Red end;
exports REG_Enum_Var;

procedure SAFE_Enum_Val(E: TEnum); safecall;
var S: String;
begin
  case E of
    Red: S := 'Red';    Blue: S := 'Blue';    Green: S := 'Green';
    else S := 'Invalid Enum value!';
  end;
  WriteLn('Enum by value: ', S);
end;
exports SAFE_Enum_Val;

procedure SAFE_Enum_Var(var E: TEnum); safecall;
begin if E < Green then Inc(E) else E := Red end;
exports SAFE_Enum_Var;

procedure PAS_Enum_Val(E: TEnum); pascal;
var S: String;
begin
  case E of
    Red: S := 'Red';    Blue: S := 'Blue';    Green: S := 'Green';
    else S := 'Invalid Enum value!';
  end;
  WriteLn('Enum by value: ', S);
end;
exports PAS_Enum_Val;

procedure PAS_Enum_Var(var E: TEnum); pascal;
begin if E < Green then Inc(E) else E := Red end;
exports PAS_Enum_Var;



//////////////////////////////////////////////////////////////////
// RANGE
//////////////////////////////////////////////////////////////////
type TRange = 0..10;
procedure STD_Range_Val(R: TRange); stdcall;
begin WriteLn('Range by value: ' + IntToStr(R)) end;
exports STD_Range_Val;

procedure STD_Range_Var(var R: TRange); stdcall;
begin Inc(R) end;
exports STD_Range_Var;

procedure REG_Range_Val(R: TRange); register;
begin WriteLn('Range by value: ' + IntToStr(R)) end;
exports REG_Range_Val;

procedure REG_Range_Var(var R: TRange); register;
begin Inc(R) end;
exports REG_Range_Var;

procedure PAS_Range_Val(R: TRange); pascal;
begin WriteLn('Range by value: ' + IntToStr(R)) end;
exports PAS_Range_Val;

procedure PAS_Range_Var(var R: TRange); pascal;
begin Inc(R) end;
exports PAS_Range_Var;

procedure CDECL_Range_Val(R: TRange); cdecl;
begin WriteLn('Range by value: ' + IntToStr(R)) end;
exports CDECL_Range_Val;

procedure CDECL_Range_Var(var R: TRange); cdecl;
begin Inc(R) end;
exports CDECL_Range_Var;

procedure SAFE_Range_Val(R: TRange); safecall;
begin WriteLn('Range by value: ' + IntToStr(R)) end;
exports SAFE_Range_Val;

procedure SAFE_Range_Var(var R: TRange); safecall;
begin Inc(R) end;
exports SAFE_Range_Var;


//////////////////////////////////////////////////////////////////
// RECORD
//////////////////////////////////////////////////////////////////
procedure STD_Record_Val(R: TRecord); stdcall;
var S: String;
begin
  S := Format('I: %d  B: %s  R: %g', [R.I, FmtBool(R.B), R.R]);
  WriteLn('Record by value: ' + S) end;
exports STD_Record_Val;

procedure STD_Record_Var(var R: TRecord); stdcall;
begin R.I := -R.I; R.B := not R.B; R.R := -R.R end;
exports STD_Record_Var;

procedure REG_Record_Val(R: TRecord); register;
var S: String;
begin
  S := Format('I: %d  B: %s  R: %g', [R.I, FmtBool(R.B), R.R]);
  WriteLn('Record by value: ' + S) end;
exports REG_Record_Val;

procedure REG_Record_Var(var R: TRecord); register;
begin R.I := -R.I; R.B := not R.B; R.R := -R.R end;
exports REG_Record_Var;

procedure PAS_Record_Val(R: TRecord); pascal;
var S: String;
begin
  S := Format('I: %d  B: %s  R: %g', [R.I, FmtBool(R.B), R.R]);
  WriteLn('Record by value: ' + S) end;
exports PAS_Record_Val;

procedure PAS_Record_Var(var R: TRecord); pascal;
begin R.I := -R.I; R.B := not R.B; R.R := -R.R end;
exports PAS_Record_Var;

procedure SAFE_Record_Val(R: TRecord); safecall;
var S: String;
begin
  S := Format('I: %d  B: %s  R: %g', [R.I, FmtBool(R.B), R.R]);
  WriteLn('Record by value: ' + S) end;
exports SAFE_Record_Val;

procedure SAFE_Record_Var(var R: TRecord); safecall;
begin R.I := -R.I; R.B := not R.B; R.R := -R.R end;
exports SAFE_Record_Var;

procedure CDECL_Record_Val(R: TRecord); cdecl;
var S: String;
begin
  S := Format('I: %d  B: %s  R: %g', [R.I, FmtBool(R.B), R.R]);
  WriteLn('Record by value: ' + S) end;
exports CDECL_Record_Val;

procedure CDECL_Record_Var(var R: TRecord); cdecl;
begin R.I := -R.I; R.B := not R.B; R.R := -R.R end;
exports CDECL_Record_Var;

/////////////////////////////////////////////////////
function STD_RetRec: TRecord; stdcall;
begin with Result do begin I:=77; B:=true; R:=3.14; end end;
exports STD_RetRec;

function STD_RetRec2: TRecord2; stdcall;
begin with Result do begin B1:=true; B2:=false; end end;
exports STD_RetRec2;

function REG_RetRec: TRecord; register;
begin
  with Result do begin I:=77; B:=true; R:=3.14; end
end;
exports REG_RetRec;

function REG_RetRec2: TRecord2; register;
begin with Result do begin B1:=true; B2:=false; end end;
exports REG_RetRec2;

function PAS_RetRec: TRecord; pascal;
begin with Result do begin I:=77; B:=true; R:=3.14; end end;
exports PAS_RetRec;

function PAS_RetRec2: TRecord2; pascal;
begin with Result do begin B1:=true; B2:=false; end end;
exports PAS_RetRec2;

function SAFE_RetRec: TRecord; safecall;
begin with Result do begin I:=77; B:=true; R:=3.14; end end;
exports SAFE_RetRec;

function SAFE_RetRec2: TRecord2; safecall;
begin with Result do begin B1:=true; B2:=false; end end;
exports SAFE_RetRec2;

function CDECL_RetRec: TRecord; cdecl;
begin with Result do begin I:=77; B:=true; R:=3.14; end end;
exports CDECL_RetRec;

function CDECL_RetRec2: TRecord2; cdecl;
begin with Result do begin B1:=true; B2:=false; end end;
exports CDECL_RetRec2;

//////////////////////////////////////////////////////////////////

procedure STD_Array1_Val(A: TArray1); stdcall;
begin WriteLn('Array1 by value: ' + '''' + A[1] + '''    ''' + A[2]+ '''')
end;
exports STD_Array1_Val;

procedure STD_Array1_Var(var A: TArray1); stdcall;
begin Inc(A[1]); Inc(A[2]) end;
exports STD_Array1_Var;

procedure STD_Array2_Val(A: TArray2); stdcall;
begin WriteLn('Array2 by value: ' + IntToStr(A[1]) + '    ' + IntToStr(A[2]))
end;
exports STD_Array2_Val;

procedure STD_Array2_Var(var A: TArray2); stdcall;
begin Inc(A[1]); Inc(A[2]) end;
exports STD_Array2_Var;


procedure REG_Array1_Val(A: TArray1); register;
begin WriteLn('Array1 by value: ' + '''' + A[1] + '''    ''' + A[2]+ '''')
end;
exports REG_Array1_Val;

procedure REG_Array1_Var(var A: TArray1); register;
begin Inc(A[1]); Inc(A[2]) end;
exports REG_Array1_Var;

procedure REG_Array2_Val(A: TArray2); register;
begin WriteLn('Array2 by value: ' + IntToStr(A[1]) + '    ' + IntToStr(A[2]))
end;
exports REG_Array2_Val;

procedure REG_Array2_Var(var A: TArray2); register;
begin Inc(A[1]); Inc(A[2]) end;
exports REG_Array2_Var;


procedure SAFE_Array1_Val(A: TArray1); safecall;
begin WriteLn('Array1 by value: ' + '''' + A[1] + '''    ''' + A[2]+ '''')
end;
exports SAFE_Array1_Val;

procedure SAFE_Array1_Var(var A: TArray1); safecall;
begin Inc(A[1]); Inc(A[2]) end;
exports SAFE_Array1_Var;

procedure SAFE_Array2_Val(A: TArray2); safecall;
begin WriteLn('Array2 by value: ' + IntToStr(A[1]) + '    ' + IntToStr(A[2]))
end;
exports SAFE_Array2_Val;

procedure SAFE_Array2_Var(var A: TArray2); safecall;
begin Inc(A[1]); Inc(A[2]) end;
exports SAFE_Array2_Var;


procedure CDECL_Array1_Val(A: TArray1); cdecl;
begin WriteLn('Array1 by value: ' + '''' + A[1] + '''    ''' + A[2]+ '''')
end;
exports CDECL_Array1_Val;

procedure CDECL_Array1_Var(var A: TArray1); cdecl;
begin Inc(A[1]); Inc(A[2]) end;
exports CDECL_Array1_Var;

procedure CDECL_Array2_Val(A: TArray2); cdecl;
begin WriteLn('Array2 by value: ' + IntToStr(A[1]) + '    ' + IntToStr(A[2]))
end;
exports CDECL_Array2_Val;

procedure CDECL_Array2_Var(var A: TArray2); cdecl;
begin Inc(A[1]); Inc(A[2]) end;
exports CDECL_Array2_Var;


procedure PAS_Array1_Val(A: TArray1); pascal;
begin WriteLn('Array1 by value: ' + '''' + A[1] + '''    ''' + A[2]+ '''')
end;
exports PAS_Array1_Val;

procedure PAS_Array1_Var(var A: TArray1); pascal;
begin Inc(A[1]); Inc(A[2]) end;
exports PAS_Array1_Var;

procedure PAS_Array2_Val(A: TArray2); pascal;
begin WriteLn('Array2 by value: ' + IntToStr(A[1]) + '    ' + IntToStr(A[2]))
end;
exports PAS_Array2_Val;

procedure PAS_Array2_Var(var A: TArray2); pascal;
begin Inc(A[1]); Inc(A[2]) end;
exports PAS_Array2_Var;


///////////////////////////////////////////////////////////
function STD_RetArr1: TArray1; stdcall;
begin
  Result[1]:='X'; Result[2]:='Y'
end;
exports STD_RetArr1;

function STD_RetArr2: TArray2; stdcall;
begin Result[1]:=111; Result[2]:=222 end;
exports STD_RetArr2;

function REG_RetArr1: TArray1; register;
begin Result[1]:='X'; Result[2]:='Y' end;
exports REG_RetArr1;

function REG_RetArr2: TArray2; register;
begin Result[1]:=111; Result[2]:=222 end;
exports REG_RetArr2;

function PAS_RetArr1: TArray1; pascal;
begin Result[1]:='X'; Result[2]:='Y' end;
exports PAS_RetArr1;

function PAS_RetArr2: TArray2; pascal;
begin Result[1]:=111; Result[2]:=222 end;
exports PAS_RetArr2;

function CDECL_RetArr1: TArray1; cdecl;
begin Result[1]:='X'; Result[2]:='Y' end;
exports CDECL_RetArr1;

function CDECL_RetArr2: TArray2; cdecl;
begin Result[1]:=111; Result[2]:=222 end;
exports CDECL_RetArr2;

function SAFE_RetArr1: TArray1; safecall;
begin Result[1]:='X'; Result[2]:='Y' end;
exports SAFE_RetArr1;

function SAFE_RetArr2: TArray2; safecall;
begin Result[1]:=111; Result[2]:=222 end;
exports SAFE_RetArr2;


//////////////////////////////////////////////////////////////////
// more ARRAY
//////////////////////////////////////////////////////////////////
function STD_SumIArr(x,y,z: integer; A: array of integer): integer; stdcall;
var i: integer;
begin
  result := 0;
  for i:= low(a) to high(a) do inc(result, a[i]);
  result := result + x*100000+y*10000+z*1000
end;
exports STD_SumIArr;

function STD_SumIArr2(x,y,z: integer; var A: array of integer): integer; stdcall;
var i: integer;
begin
  result := 0;
  for i:= low(a) to high(a) do inc(result, a[i]);
  result := result + x*100000+y*10000+z*1000
end;
exports STD_SumIArr2;

function REG_SumIArr(x,y,z: integer; A: array of integer): integer; register;
var i: integer;
begin
  result := 0;
  for i:= low(a) to high(a) do inc(result, a[i]);
  result := result + x*100000+y*10000+z*1000
end;
exports REG_SumIArr;

function REG_SumIArr2(x,y,z: integer; var A: array of integer): integer; register;
var i: integer;
begin
  result := 0;
  for i:= low(a) to high(a) do inc(result, a[i]);
  result := result + x*100000+y*10000+z*1000
end;
exports REG_SumIArr2;

function PAS_SumIArr(x,y,z: integer; A: array of integer): integer; pascal;
var i: integer;
begin
  result := 0;
  for i:= low(a) to high(a) do inc(result, a[i]);
  result := result + x*100000+y*10000+z*1000
end;
exports PAS_SumIArr;

function PAS_SumIArr2(x,y,z: integer; var A: array of integer): integer; pascal;
var i: integer;
begin
  result := 0;
  for i:= low(a) to high(a) do inc(result, a[i]);
  result := result + x*100000+y*10000+z*1000
end;
exports PAS_SumIArr2;

function SAFE_SumIArr(x,y,z: integer; A: array of integer): integer; safecall;
var i: integer;
begin
  result := 0;
  for i:= low(a) to high(a) do inc(result, a[i]);
  result := result + x*100000+y*10000+z*1000
end;
exports SAFE_SumIArr;

function SAFE_SumIArr2(x,y,z: integer; var A: array of integer): integer; safecall;
var i: integer;
begin
  result := 0;
  for i:= low(a) to high(a) do inc(result, a[i]);
  result := result + x*100000+y*10000+z*1000
end;
exports SAFE_SumIArr2;

function CDECL_SumIArr(x,y,z: integer; A: array of integer): integer; cdecl;
var i: integer;
begin
  result := 0;
  for i:= low(a) to high(a) do inc(result, a[i]);
  result := result + x*100000+y*10000+z*1000
end;
exports CDECL_SumIArr;

function CDECL_SumIArr2(x,y,z: integer; var A: array of integer): integer; cdecl;
var i: integer;
begin
  result := 0;
  for i:= low(a) to high(a) do inc(result, a[i]);
  result := result + x*100000+y*10000+z*1000
end;
exports CDECL_SumIArr2;

//////////////////////////////
function PAS_Sum3(X, Y, Z: Integer): Integer; pascal;
var S: String;
begin Result := X+Y+Z;
  S := IntToStr(X) + CRLF + IntToStr(Y) + CRLF + IntToStr(Z) + CRLF;
  WriteLn(S);
end;
exports PAS_Sum3;

function STD_Sum3(X, Y, Z: Integer): Integer; stdcall;
var S: String;
begin Result := X+Y+Z;
  S := IntToStr(X) + CRLF + IntToStr(Y) + CRLF + IntToStr(Z) + CRLF;
  WriteLn(S);
end;
exports STD_Sum3;

function REG_Sum3(X, Y, Z: Integer): Integer; register;
var S: String;
begin Result := X+Y+Z;
  S := IntToStr(X) + CRLF + IntToStr(Y) + CRLF + IntToStr(Z) + CRLF;
  WriteLn(S);
end;
exports REG_Sum3;

function SAFE_Sum3(X, Y, Z: Integer): Integer; safecall;
var S: String;
begin Result := X+Y+Z;
  S := IntToStr(X) + CRLF + IntToStr(Y) + CRLF + IntToStr(Z) + CRLF;
  WriteLn(S);
end;
exports SAFE_Sum3;

function CDECL_Sum3(X, Y, Z: Integer): Integer; cdecl;
var S: String;
begin Result := X+Y+Z;
  S := IntToStr(X) + CRLF + IntToStr(Y) + CRLF + IntToStr(Z) + CRLF;
  WriteLn(S);
end;
exports CDECL_Sum3;

//////////////////////////////
function STD_Variant(V1, V2: Variant; var V3: Variant): Variant; stdcall;
begin Result := V1+V2+V3 end;
exports STD_Variant;

function REG_Variant(V1, V2: Variant; var V3: Variant): Variant; register;
begin Result := V1+V2+V3 end;
exports REG_Variant;

function PAS_Variant(V1, V2: Variant; var V3: Variant): Variant; pascal;
begin Result := V1+V2+V3 end;
exports PAS_Variant;

function SAFE_Variant(V1, V2: Variant; var V3: Variant): Variant; safecall;
begin Result := V1+V2+V3 end;
exports SAFE_Variant;

function CDECL_Variant(V1, V2: Variant; var V3: Variant): Variant; cdecl;
begin Result := V1+V2+V3 end;
exports CDECL_Variant;


begin
end.