// A poly data type demo program. Lee algorithm
//

program Lee;
const
  X = 1; 
  Y = 2;
  MaxPathLength = 20;

function Obstructs(const P, OBS: Poly): boolean;
var
  L, R : Poly;
  I : Integer;
begin
  result := false;
  for I:=1 to Length(OBS) do
  begin
    L == OBS[I, 1];
    R == OBS[I, 2];
    result := ( Integer(P[X]) >= Integer(L[X]) ) and 
              ( Integer(P[X]) <= Integer(R[X]) ) and 
              ( Integer(P[Y]) >= Integer(L[Y]) ) and 
              ( Integer(P[Y]) <= Integer(R[Y]) );
    if result then
      Exit;  
  end;
end;

function Member(const Point, Wave : Poly) : boolean;
var
  P : Poly;
begin
  result := false;
  P == Wave;
  while Assigned(P) do
  begin
    if Point = P[1] then
    begin
      result := true;
      Exit;
    end;
    P == P[2];
  end;
end;

function Neighbor(const U, V : Poly): boolean;
var
  b1, b2 : boolean;
begin
  b1 := (U[X] = V[X]) and
        (Abs(Integer(U[Y]) - Integer(V[Y])) = 1);
  b2 := (U[Y] = V[Y]) and
        (Abs(Integer(U[X]) - Integer(V[X])) = 1);
  result := b1 or b2;
end;

function Path(const A, B, OBS: Poly): Poly;
type
  TPoint = record
             X, Y : Integer;
           end;
var
  V, N, NI, P, Q, PrevWave, CurrWave, NextWave : Poly;
  I, J, K : Integer;
  Point : TPoint;
begin
  SetLength(V, MaxPathLength + 1);

  V[1] := [A, *];
  for K:=1 to MaxPathLength do
  begin
    if K > 1 then
      PrevWave == V[K-1];
    CurrWave == V[K];
    NextWave == V[K+1];
    P == CurrWave;
    while Assigned(P) do
    begin
      Point.X := Integer(P[1][X]);
      Point.Y := Integer(P[1][Y]);

      SetLength(N, 4);

      N[1] := [Point.X + 1, Point.Y];
      N[2] := [Point.X, Point.Y + 1];
      if Point.X > 0 then
        N[3] := [Point.X - 1, Point.Y];
      if Point.Y > 0 then
        N[4] := [Point.X, Point.Y - 1];

      for I:=1 to 4 do
      begin
        NI == N[I];

        if Assigned(NI) then
        begin
          if NI = B then
          begin
            Result << [NI, << Result];
            J := K;
            while J > 0 do
            begin
              P == V[J];
              while Assigned(P) do
              begin
                if Neighbor(P[1], NI) then
                begin
                  NI == P[1];
                  Result << [NI, << Result];
                  Break;
                end;
                P == P[2];
              end;
              Dec(J);
            end;
            Exit;
          end
          else
          begin
            if not ( Member(NI, PrevWave) or
                     Member(NI, CurrWave) or
                     Member(NI, NextWave) or
                     Obstructs(NI, OBS)) then
              NextWave << [NI, << NextWave];
          end;
        end;
      end;
      deallocate N;
      P == P[2];
    end;
  end;
end;

const
  N = 3;
var
  OBS, PS, PD, Result : Poly;
  I : Integer;
begin
  SetLength( OBS, N );
  OBS[1] := [[2, 3], [4, 5]];
  OBS[2] := [[6, 6], [8, 8]];
  OBS[3] := [[4, 7], [5, 9]];

  writeln('Obstacles:');
  for I:=1 to N do
    writeln( OBS[I] );

  PS := [1,1];
  writeln('Source point:');
  writeln( PS );
  PD := [7,9];
  writeln('Destination point:');
  writeln( PD );

  Result := Path(PS, PD, OBS);

  if not Assigned(Result) then
    writeln('Path not found')
  else
    writeln('Path:', Result);
end.

